Commits

Greg Newman  committed feeafd2

adding org-check, a cool tool

  • Participants
  • Parent commits 6840aed

Comments (0)

Files changed (25)

File src/org-check/.git/HEAD

+ref: refs/heads/master

File src/org-check/.git/config

+[core]
+	repositoryformatversion = 0
+	filemode = true
+	bare = false
+	logallrefupdates = true
+	ignorecase = true
+[remote "origin"]
+	fetch = +refs/heads/*:refs/remotes/origin/*
+	url = git://github.com/tsdye/org-check.git
+[branch "master"]
+	remote = origin
+	merge = refs/heads/master

File src/org-check/.git/description

+Unnamed repository; edit this file 'description' to name the repository.

File src/org-check/.git/hooks/applypatch-msg.sample

+#!/bin/sh
+#
+# An example hook script to check the commit log message taken by
+# applypatch from an e-mail message.
+#
+# The hook should exit with non-zero status after issuing an
+# appropriate message if it wants to stop the commit.  The hook is
+# allowed to edit the commit message file.
+#
+# To enable this hook, rename this file to "applypatch-msg".
+
+. git-sh-setup
+test -x "$GIT_DIR/hooks/commit-msg" &&
+	exec "$GIT_DIR/hooks/commit-msg" ${1+"$@"}
+:

File src/org-check/.git/hooks/commit-msg.sample

+#!/bin/sh
+#
+# An example hook script to check the commit log message.
+# Called by git-commit with one argument, the name of the file
+# that has the commit message.  The hook should exit with non-zero
+# status after issuing an appropriate message if it wants to stop the
+# commit.  The hook is allowed to edit the commit message file.
+#
+# To enable this hook, rename this file to "commit-msg".
+
+# Uncomment the below to add a Signed-off-by line to the message.
+# Doing this in a hook is a bad idea in general, but the prepare-commit-msg
+# hook is more suited to it.
+#
+# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
+# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"
+
+# This example catches duplicate Signed-off-by lines.
+
+test "" = "$(grep '^Signed-off-by: ' "$1" |
+	 sort | uniq -c | sed -e '/^[ 	]*1[ 	]/d')" || {
+	echo >&2 Duplicate Signed-off-by lines.
+	exit 1
+}

File src/org-check/.git/hooks/post-commit.sample

+#!/bin/sh
+#
+# An example hook script that is called after a successful
+# commit is made.
+#
+# To enable this hook, rename this file to "post-commit".
+
+: Nothing

File src/org-check/.git/hooks/post-receive.sample

+#!/bin/sh
+#
+# An example hook script for the "post-receive" event.
+#
+# The "post-receive" script is run after receive-pack has accepted a pack
+# and the repository has been updated.  It is passed arguments in through
+# stdin in the form
+#  <oldrev> <newrev> <refname>
+# For example:
+#  aa453216d1b3e49e7f6f98441fa56946ddcd6a20 68f7abf4e6f922807889f52bc043ecd31b79f814 refs/heads/master
+#
+# see contrib/hooks/ for an sample, or uncomment the next line and
+# rename the file to "post-receive".
+
+#. /usr/share/doc/git-core/contrib/hooks/post-receive-email

File src/org-check/.git/hooks/post-update.sample

+#!/bin/sh
+#
+# An example hook script to prepare a packed repository for use over
+# dumb transports.
+#
+# To enable this hook, rename this file to "post-update".
+
+exec git-update-server-info

File src/org-check/.git/hooks/pre-applypatch.sample

+#!/bin/sh
+#
+# An example hook script to verify what is about to be committed
+# by applypatch from an e-mail message.
+#
+# The hook should exit with non-zero status after issuing an
+# appropriate message if it wants to stop the commit.
+#
+# To enable this hook, rename this file to "pre-applypatch".
+
+. git-sh-setup
+test -x "$GIT_DIR/hooks/pre-commit" &&
+	exec "$GIT_DIR/hooks/pre-commit" ${1+"$@"}
+:

File src/org-check/.git/hooks/pre-commit.sample

+#!/bin/sh
+#
+# An example hook script to verify what is about to be committed.
+# Called by git-commit with no arguments.  The hook should
+# exit with non-zero status after issuing an appropriate message if
+# it wants to stop the commit.
+#
+# To enable this hook, rename this file to "pre-commit".
+
+# If you want to allow non-ascii filenames set this variable to true.
+allownonascii=$(git config hooks.allownonascii)
+
+# Cross platform projects tend to avoid non-ascii filenames; prevent
+# them from being added to the repository. We exploit the fact that the
+# printable range starts at the space character and ends with tilde.
+if [ "$allownonascii" != "true" ] &&
+	test "$(git diff --cached --name-only --diff-filter=A -z |
+	  LC_ALL=C tr -d '[ -~]\0')"
+then
+	echo "Error: Attempt to add a non-ascii filename."
+	echo
+	echo "This can cause problems if you want to work together"
+	echo "with people on other platforms than you."
+	echo
+	echo "To be portable it is adviseable to rename the file ..."
+	echo
+	echo "If you know what you are doing you can disable this"
+	echo "check using:"
+	echo
+	echo "  git config hooks.allownonascii true"
+	echo
+	exit 1
+fi
+
+if git-rev-parse --verify HEAD >/dev/null 2>&1
+then
+	against=HEAD
+else
+	# Initial commit: diff against an empty tree object
+	against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
+fi
+
+exec git diff-index --check --cached $against --

File src/org-check/.git/hooks/pre-rebase.sample

+#!/bin/sh
+#
+# Copyright (c) 2006, 2008 Junio C Hamano
+#
+# The "pre-rebase" hook is run just before "git-rebase" starts doing
+# its job, and can prevent the command from running by exiting with
+# non-zero status.
+#
+# The hook is called with the following parameters:
+#
+# $1 -- the upstream the series was forked from.
+# $2 -- the branch being rebased (or empty when rebasing the current branch).
+#
+# This sample shows how to prevent topic branches that are already
+# merged to 'next' branch from getting rebased, because allowing it
+# would result in rebasing already published history.
+
+publish=next
+basebranch="$1"
+if test "$#" = 2
+then
+	topic="refs/heads/$2"
+else
+	topic=`git symbolic-ref HEAD` ||
+	exit 0 ;# we do not interrupt rebasing detached HEAD
+fi
+
+case "$topic" in
+refs/heads/??/*)
+	;;
+*)
+	exit 0 ;# we do not interrupt others.
+	;;
+esac
+
+# Now we are dealing with a topic branch being rebased
+# on top of master.  Is it OK to rebase it?
+
+# Does the topic really exist?
+git show-ref -q "$topic" || {
+	echo >&2 "No such branch $topic"
+	exit 1
+}
+
+# Is topic fully merged to master?
+not_in_master=`git-rev-list --pretty=oneline ^master "$topic"`
+if test -z "$not_in_master"
+then
+	echo >&2 "$topic is fully merged to master; better remove it."
+	exit 1 ;# we could allow it, but there is no point.
+fi
+
+# Is topic ever merged to next?  If so you should not be rebasing it.
+only_next_1=`git-rev-list ^master "^$topic" ${publish} | sort`
+only_next_2=`git-rev-list ^master           ${publish} | sort`
+if test "$only_next_1" = "$only_next_2"
+then
+	not_in_topic=`git-rev-list "^$topic" master`
+	if test -z "$not_in_topic"
+	then
+		echo >&2 "$topic is already up-to-date with master"
+		exit 1 ;# we could allow it, but there is no point.
+	else
+		exit 0
+	fi
+else
+	not_in_next=`git-rev-list --pretty=oneline ^${publish} "$topic"`
+	perl -e '
+		my $topic = $ARGV[0];
+		my $msg = "* $topic has commits already merged to public branch:\n";
+		my (%not_in_next) = map {
+			/^([0-9a-f]+) /;
+			($1 => 1);
+		} split(/\n/, $ARGV[1]);
+		for my $elem (map {
+				/^([0-9a-f]+) (.*)$/;
+				[$1 => $2];
+			} split(/\n/, $ARGV[2])) {
+			if (!exists $not_in_next{$elem->[0]}) {
+				if ($msg) {
+					print STDERR $msg;
+					undef $msg;
+				}
+				print STDERR " $elem->[1]\n";
+			}
+		}
+	' "$topic" "$not_in_next" "$not_in_master"
+	exit 1
+fi
+
+exit 0
+
+################################################################
+
+This sample hook safeguards topic branches that have been
+published from being rewound.
+
+The workflow assumed here is:
+
+ * Once a topic branch forks from "master", "master" is never
+   merged into it again (either directly or indirectly).
+
+ * Once a topic branch is fully cooked and merged into "master",
+   it is deleted.  If you need to build on top of it to correct
+   earlier mistakes, a new topic branch is created by forking at
+   the tip of the "master".  This is not strictly necessary, but
+   it makes it easier to keep your history simple.
+
+ * Whenever you need to test or publish your changes to topic
+   branches, merge them into "next" branch.
+
+The script, being an example, hardcodes the publish branch name
+to be "next", but it is trivial to make it configurable via
+$GIT_DIR/config mechanism.
+
+With this workflow, you would want to know:
+
+(1) ... if a topic branch has ever been merged to "next".  Young
+    topic branches can have stupid mistakes you would rather
+    clean up before publishing, and things that have not been
+    merged into other branches can be easily rebased without
+    affecting other people.  But once it is published, you would
+    not want to rewind it.
+
+(2) ... if a topic branch has been fully merged to "master".
+    Then you can delete it.  More importantly, you should not
+    build on top of it -- other people may already want to
+    change things related to the topic as patches against your
+    "master", so if you need further changes, it is better to
+    fork the topic (perhaps with the same name) afresh from the
+    tip of "master".
+
+Let's look at this example:
+
+		   o---o---o---o---o---o---o---o---o---o "next"
+		  /       /           /           /
+		 /   a---a---b A     /           /
+		/   /               /           /
+	       /   /   c---c---c---c B         /
+	      /   /   /             \         /
+	     /   /   /   b---b C     \       /
+	    /   /   /   /             \     /
+    ---o---o---o---o---o---o---o---o---o---o---o "master"
+
+
+A, B and C are topic branches.
+
+ * A has one fix since it was merged up to "next".
+
+ * B has finished.  It has been fully merged up to "master" and "next",
+   and is ready to be deleted.
+
+ * C has not merged to "next" at all.
+
+We would want to allow C to be rebased, refuse A, and encourage
+B to be deleted.
+
+To compute (1):
+
+	git-rev-list ^master ^topic next
+	git-rev-list ^master        next
+
+	if these match, topic has not merged in next at all.
+
+To compute (2):
+
+	git-rev-list master..topic
+
+	if this is empty, it is fully merged to "master".

File src/org-check/.git/hooks/prepare-commit-msg.sample

+#!/bin/sh
+#
+# An example hook script to prepare the commit log message.
+# Called by git-commit with the name of the file that has the
+# commit message, followed by the description of the commit
+# message's source.  The hook's purpose is to edit the commit
+# message file.  If the hook fails with a non-zero status,
+# the commit is aborted.
+#
+# To enable this hook, rename this file to "prepare-commit-msg".
+
+# This hook includes three examples.  The first comments out the
+# "Conflicts:" part of a merge commit.
+#
+# The second includes the output of "git diff --name-status -r"
+# into the message, just before the "git status" output.  It is
+# commented because it doesn't cope with --amend or with squashed
+# commits.
+#
+# The third example adds a Signed-off-by line to the message, that can
+# still be edited.  This is rarely a good idea.
+
+case "$2,$3" in
+  merge,)
+    perl -i.bak -ne 's/^/# /, s/^# #/#/ if /^Conflicts/ .. /#/; print' "$1" ;;
+
+# ,|template,)
+#   perl -i.bak -pe '
+#      print "\n" . `git diff --cached --name-status -r`
+#	 if /^#/ && $first++ == 0' "$1" ;;
+
+  *) ;;
+esac
+
+# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
+# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"

File src/org-check/.git/hooks/update.sample

+#!/bin/sh
+#
+# An example hook script to blocks unannotated tags from entering.
+# Called by git-receive-pack with arguments: refname sha1-old sha1-new
+#
+# To enable this hook, rename this file to "update".
+#
+# Config
+# ------
+# hooks.allowunannotated
+#   This boolean sets whether unannotated tags will be allowed into the
+#   repository.  By default they won't be.
+# hooks.allowdeletetag
+#   This boolean sets whether deleting tags will be allowed in the
+#   repository.  By default they won't be.
+# hooks.allowmodifytag
+#   This boolean sets whether a tag may be modified after creation. By default
+#   it won't be.
+# hooks.allowdeletebranch
+#   This boolean sets whether deleting branches will be allowed in the
+#   repository.  By default they won't be.
+# hooks.denycreatebranch
+#   This boolean sets whether remotely creating branches will be denied
+#   in the repository.  By default this is allowed.
+#
+
+# --- Command line
+refname="$1"
+oldrev="$2"
+newrev="$3"
+
+# --- Safety check
+if [ -z "$GIT_DIR" ]; then
+	echo "Don't run this script from the command line." >&2
+	echo " (if you want, you could supply GIT_DIR then run" >&2
+	echo "  $0 <ref> <oldrev> <newrev>)" >&2
+	exit 1
+fi
+
+if [ -z "$refname" -o -z "$oldrev" -o -z "$newrev" ]; then
+	echo "Usage: $0 <ref> <oldrev> <newrev>" >&2
+	exit 1
+fi
+
+# --- Config
+allowunannotated=$(git config --bool hooks.allowunannotated)
+allowdeletebranch=$(git config --bool hooks.allowdeletebranch)
+denycreatebranch=$(git config --bool hooks.denycreatebranch)
+allowdeletetag=$(git config --bool hooks.allowdeletetag)
+allowmodifytag=$(git config --bool hooks.allowmodifytag)
+
+# check for no description
+projectdesc=$(sed -e '1q' "$GIT_DIR/description")
+case "$projectdesc" in
+"Unnamed repository"* | "")
+	echo "*** Project description file hasn't been set" >&2
+	exit 1
+	;;
+esac
+
+# --- Check types
+# if $newrev is 0000...0000, it's a commit to delete a ref.
+zero="0000000000000000000000000000000000000000"
+if [ "$newrev" = "$zero" ]; then
+	newrev_type=delete
+else
+	newrev_type=$(git-cat-file -t $newrev)
+fi
+
+case "$refname","$newrev_type" in
+	refs/tags/*,commit)
+		# un-annotated tag
+		short_refname=${refname##refs/tags/}
+		if [ "$allowunannotated" != "true" ]; then
+			echo "*** The un-annotated tag, $short_refname, is not allowed in this repository" >&2
+			echo "*** Use 'git tag [ -a | -s ]' for tags you want to propagate." >&2
+			exit 1
+		fi
+		;;
+	refs/tags/*,delete)
+		# delete tag
+		if [ "$allowdeletetag" != "true" ]; then
+			echo "*** Deleting a tag is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/tags/*,tag)
+		# annotated tag
+		if [ "$allowmodifytag" != "true" ] && git rev-parse $refname > /dev/null 2>&1
+		then
+			echo "*** Tag '$refname' already exists." >&2
+			echo "*** Modifying a tag is not allowed in this repository." >&2
+			exit 1
+		fi
+		;;
+	refs/heads/*,commit)
+		# branch
+		if [ "$oldrev" = "$zero" -a "$denycreatebranch" = "true" ]; then
+			echo "*** Creating a branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/heads/*,delete)
+		# delete branch
+		if [ "$allowdeletebranch" != "true" ]; then
+			echo "*** Deleting a branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/remotes/*,commit)
+		# tracking branch
+		;;
+	refs/remotes/*,delete)
+		# delete tracking branch
+		if [ "$allowdeletebranch" != "true" ]; then
+			echo "*** Deleting a tracking branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	*)
+		# Anything else (is there anything else?)
+		echo "*** Update hook: unknown type of update to ref $refname of type $newrev_type" >&2
+		exit 1
+		;;
+esac
+
+# --- Finished
+exit 0

File src/org-check/.git/index

Binary file added.

File src/org-check/.git/info/exclude

+# git-ls-files --others --exclude-from=.git/info/exclude
+# Lines that start with '#' are comments.
+# For a project mostly in C, the following would be a good set of
+# exclude patterns (uncomment them if you want to use them):
+# *.[oa]
+# *~
+.DS_Store

File src/org-check/.git/logs/HEAD

+0000000000000000000000000000000000000000 fb9af8fad8f180294ea66323c548142a2887ca7c Greg Newman <greg@20seven.org> 1270855375 -0400	clone: from git://github.com/tsdye/org-check.git

File src/org-check/.git/logs/refs/heads/master

+0000000000000000000000000000000000000000 fb9af8fad8f180294ea66323c548142a2887ca7c Greg Newman <greg@20seven.org> 1270855375 -0400	clone: from git://github.com/tsdye/org-check.git

File src/org-check/.git/logs/refs/remotes/origin/HEAD

+0000000000000000000000000000000000000000 fb9af8fad8f180294ea66323c548142a2887ca7c Greg Newman <greg@20seven.org> 1270855375 -0400	clone: from git://github.com/tsdye/org-check.git

File src/org-check/.git/objects/pack/pack-45056743dbb199560e46c1ddd9e85d817649f881.idx

Binary file added.

File src/org-check/.git/objects/pack/pack-45056743dbb199560e46c1ddd9e85d817649f881.pack

Binary file added.

File src/org-check/.git/packed-refs

+# pack-refs with: peeled 
+fb9af8fad8f180294ea66323c548142a2887ca7c refs/remotes/origin/master

File src/org-check/.git/refs/heads/master

+fb9af8fad8f180294ea66323c548142a2887ca7c

File src/org-check/.git/refs/remotes/origin/HEAD

+ref: refs/remotes/origin/master

File src/org-check/README

+The file org-check.org is a stub for a file that provides facilities for checking an org-mode configuration.  Eric Schulte set up the table and either wrote or corrected most of the elisp and shell code in the original version.

File src/org-check/org-check.org

+#+TITLE: Verify an Org-mode environment
+#+OPTIONS: num:nil ^:nil
+#+LaTeX_CLASS: normal
+#+STARTUP: hideblocks
+#+TODO: TODO | DONE
+
+Check an Org-mode environment.
+
+*warning*: executing the table in this buffer will execute elisp and
+ shell commands on your system.  These commands are intended to check
+ aspects of your environment for compatibility with Org-mode, however
+ malicious people could tie arbitrary and/or malicious code blocks to
+ this table.
+ - don't be malicious, only put reasonable code into this buffer
+ - don't be angry, you've been warned about the possible risks of
+   using this buffer
+   
+ In general Org-moders are very nice and will most likely keep this
+ buffer both safe and useful.
+
+* Instructions
+  - Download the file [[http://org-babel.tsdye2.com/org-check.org][org-check.org]]
+  - Calculate the table by putting point in the table and pressing =C-u C-c *=
+  - Check the =results= column
+    - if you see all "pass" results, then your environment passes
+    - if you see "fail" or other results, then follow the link in the
+      =task= column for an explanation 
+
+| task          | topic            | command                    | results |
+|---------------+------------------+----------------------------+---------|
+| [[*Preview%20LaTeX][preview latex]] |                  |                            |         |
+|               | [[* latex][latex]]            | check-latex-command        | pass    |
+|               | [[* check-latex-system][latex-system]]     | check-latex-system         | pass    |
+|               | [[* dvipng][dvipng]]           | check-dvipng-command       | pass    |
+|               | [[*check-dvipng-system][dvipng-system]]    | check-dvipng-system        | pass    |
+|               | [[*check-latex-scale][latex-scale]]      | check-latex-scale          | 1.0     |
+| [[*Make%20pdf%20files][make pdfs]]     |                  |                            |         |
+|               | [[* latex][latex]]            | check-latex-command        | pass    |
+| [[*Agenda][agenda]]        |                  |                            |         |
+|               | [[* org-agenda-files][org-agenda-files]] | check-org-agenda-files-set | pass    |
+#+TBLFM: $4='(sbe $3)
+
+* Commands
+
+** =latex= command
+The =latex= command must be findable by Emacs in order to generate
+pdfs or preview latex fragments in buffer.  This command checks to see
+if latex is found anywhere on =exec-path=.
+
+#+srcname: check-latex-command
+#+begin_src emacs-lisp :results silent
+   (if (org-check-external-command "latex" "" t) "pass" "fail")
+#+end_src
+
+** =dvipng= command
+The =dvipng= command must be findable by Emacs in order to preview
+latex fragments in buffer.  This command checks for dvipng on =exec-path=.
+
+#+srcname: check-dvipng-command
+#+begin_src emacs-lisp :results silent
+   (if (org-check-external-command "dvipng" "" t) "pass" "fail")
+#+end_src
+   
+** =org-agenda-files= is very useful
+Although not explicitly required for normal use the `[[elisp:(progn (describe-variable 'org-agenda-files) (other-window 1))][org-agenda-files]]'
+variable is required for a number of useful org-mode commands
+including the following.
+- `[[elisp:(progn (describe-function 'org-agenda) (other-window 1))][org-agenda]]'
+- `[[elisp:(progn (describe-variable 'org-export-icalendar-combine-agenda-files) (other-window 1))][org-export-icalendar-combine-agenda-files]]'
+- others?
+
+#+srcname: check-org-agenda-files-set
+#+begin_src emacs-lisp :results silent
+  (if (null org-agenda-files)
+      "consider setting [[* org-agenda-files][org-agenda-files]]"
+    "pass")
+#+end_src
+
+** =check-latex-system=
+See if LaTeX is present on the *nix system, regardless of whether it
+is found on the Emacs =exec-path=.
+
+#+srcname: check-latex-system
+#+begin_src sh :results silent
+    if which latex > /dev/null;
+    then echo pass;
+    else echo fail;
+    fi
+#+end_src
+
+** =check-dvipng-system=
+See if dvipng is present on the *nix system, regardless of whether it
+is found on the Emacs =exec-path=.
+
+#+srcname: check-dvipng-system
+#+begin_src sh :results silent
+    if which dvipng > /dev/null;
+    then echo pass;
+    else echo fail;
+    fi
+#+end_src
+
+** =check-latex-scale=
+Report the scale setting for inline images.  Default is 1.0.
+
+#+srcname: check-latex-scale
+#+begin_src emacs-lisp :results silent
+  (plist-get org-format-latex-options :scale)
+#+end_src
+
+* Tasks
+** Preview LaTeX
+   - Previewing LaTeX in the Org-mode buffer requires: 
+     - a working LaTeX installation, including the =latex= executable
+     - the [[http://sourceforge.net/projects/dvipng/][dvipng]] executable
+     - paths to these executables on =exec-path=
+   - If either latex-system or dvipng-system fails, then you probably
+     need to install software
+   - If latex-system passes and latex fails, then you need to modify
+     the variable =exec-path=, so the path to the latex executable is
+     included 
+   - If dvipng-system passes and dvipng fails, then you need to modify
+     the variable =exec-path=, so the path to the dvipng executable is
+     included 
+   - Image size can be scaled using the =:scale= property of the
+     variable =org-format-latex-options=
+** Make pdf files
+** Agenda
+
+* Notes                                                            :noexport:
+** TODO Provide a link to the org-check.org file in Instructions
+** TODO Check, does Windows have something like which?
+   - which is used in the shell scripts td wrote to check for latex
+     and dvipng commands at the system level